---
title: Create Entry and entryUUID
description: You can create a new entry using the parent DN. The response shows the entry data, including the generated entryUUID attribute value associated with the entry resource. The entryUUID can be used to reference the entry, keeping confidential information from appearing in the DN.
component: pingdirectory
page_id: pingdirectory:directory:directory-entry-apis/create-entry-and-entryUUID
canonical_url: https://developer.pingidentity.com/pingdirectory/directory/directory-entry-apis/create-entry-and-entryUUID.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Entry and entryUUID

##

```none
POST {{apiPath}}/directory/v1
```

You can create a new entry using the parent DN. The response shows the entry data, including the generated `entryUUID` attribute value associated with the entry resource. The `entryUUID` can be used to reference the entry, keeping confidential information from appearing in the DN.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones"
    ],
    "sn": [
        "Jones"
    ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/directory/v1' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones"
    ],
    "sn": [
        "Jones"
    ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/directory/v1")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""_parentDN"": ""ou=people,dc=example,dc=com""," + "\n" +
@"    ""objectClass"": [" + "\n" +
@"        ""top""," + "\n" +
@"        ""person""," + "\n" +
@"        ""organizationalPerson""," + "\n" +
@"        ""inetOrgPerson""" + "\n" +
@"    ]," + "\n" +
@"    ""uid"": [" + "\n" +
@"        ""lindajones""" + "\n" +
@"    ]," + "\n" +
@"    ""cn"": [" + "\n" +
@"        ""Linda Jones""" + "\n" +
@"    ]," + "\n" +
@"    ""sn"": [" + "\n" +
@"        ""Jones""" + "\n" +
@"    ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/directory/v1"
  method := "POST"

  payload := strings.NewReader(`{
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones"
    ],
    "sn": [
        "Jones"
    ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /directory/v1 HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones"
    ],
    "sn": [
        "Jones"
    ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"_parentDN\": \"ou=people,dc=example,dc=com\",\n    \"objectClass\": [\n        \"top\",\n        \"person\",\n        \"organizationalPerson\",\n        \"inetOrgPerson\"\n    ],\n    \"uid\": [\n        \"lindajones\"\n    ],\n    \"cn\": [\n        \"Linda Jones\"\n    ],\n    \"sn\": [\n        \"Jones\"\n    ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/directory/v1")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/directory/v1",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
      "top",
      "person",
      "organizationalPerson",
      "inetOrgPerson"
    ],
    "uid": [
      "lindajones"
    ],
    "cn": [
      "Linda Jones"
    ],
    "sn": [
      "Jones"
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/directory/v1',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "_parentDN": "ou=people,dc=example,dc=com",
    "objectClass": [
      "top",
      "person",
      "organizationalPerson",
      "inetOrgPerson"
    ],
    "uid": [
      "lindajones"
    ],
    "cn": [
      "Linda Jones"
    ],
    "sn": [
      "Jones"
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/directory/v1"

payload = json.dumps({
  "_parentDN": "ou=people,dc=example,dc=com",
  "objectClass": [
    "top",
    "person",
    "organizationalPerson",
    "inetOrgPerson"
  ],
  "uid": [
    "lindajones"
  ],
  "cn": [
    "Linda Jones"
  ],
  "sn": [
    "Jones"
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/directory/v1');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "_parentDN": "ou=people,dc=example,dc=com",\n    "objectClass": [\n        "top",\n        "person",\n        "organizationalPerson",\n        "inetOrgPerson"\n    ],\n    "uid": [\n        "lindajones"\n    ],\n    "cn": [\n        "Linda Jones"\n    ],\n    "sn": [\n        "Jones"\n    ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/directory/v1")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "_parentDN": "ou=people,dc=example,dc=com",
  "objectClass": [
    "top",
    "person",
    "organizationalPerson",
    "inetOrgPerson"
  ],
  "uid": [
    "lindajones"
  ],
  "cn": [
    "Linda Jones"
  ],
  "sn": [
    "Jones"
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"_parentDN\": \"ou=people,dc=example,dc=com\",\n    \"objectClass\": [\n        \"top\",\n        \"person\",\n        \"organizationalPerson\",\n        \"inetOrgPerson\"\n    ],\n    \"uid\": [\n        \"lindajones\"\n    ],\n    \"cn\": [\n        \"Linda Jones\"\n    ],\n    \"sn\": [\n        \"Jones\"\n    ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/directory/v1")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_dn": "entryUUID=a4fbd3ca-f7a0-42f2-af66-13f2c0dd8cd1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "person",
        "organizationalPerson",
        "inetOrgPerson"
    ],
    "uid": [
        "lindajones"
    ],
    "cn": [
        "Linda Jones"
    ],
    "sn": [
        "Jones"
    ],
    "_links": {
        "schemas": [
            {
                "href": "https://ds.example.com/directory/v1/schemas/inetOrgPerson"
            }
        ],
        "self": {
            "href": "https://ds.example.com/directory/v1/entryUUID=a4fbd3ca-f7a0-42f2-af66-13f2c0dd8cd1,ou=people,dc=example,dc=com"
        }
    }
}
```
